//Ryder Lua by SMS Alfredo and DirkTheHusky

mobjinfo[MT_CYBRAKDEMON_ELECTRIC_BARRIER].flags = $ &~ MF_PUSHABLE

local PICKUPTIME = TICRATE/4
local THROWHEIGHT = 96
local THROWSPEED = 32
local MAXBLOCKS = 5

for i = 1, 6
	freeslot("SPR_RYD"..i)
end

states[freeslot("S_RYDER_CRUMBLE")] = {SPR_RYD2, FF_ANIMATE|FF_RANDOMANIM, TICRATE*4, nil, 7, 2, S_NULL}
states[freeslot("S_RYDER_STUN")] = {SPR_PLAY, SPR2_STUN, TICRATE/2, nil, 0, 0, S_PLAY_WALK}

states[freeslot("S_RYDER_FLAREHUG1")] = {SPR_RYD3, 0, -1, nil, 0, 0, S_RYDER_FLAREHUG1}
states[freeslot("S_RYDER_FLAREHUG2")] = {SPR_RYD3, B, -1, nil, 0, 0, S_RYDER_FLAREHUG2}

states[freeslot("S_FLARE_RYDERHUG1")] = {SPR_RYD4, 0, -1, nil, 0, 0, S_FLARE_RYDERHUG1}
states[freeslot("S_FLARE_RYDERHUG2")] = {SPR_RYD5, 0, -1, nil, 0, 0, S_FLARE_RYDERHUG2}

//ryderflipaim command
local ryderflipaim = function(player, arg)
	if arg
		arg = string.lower($)
		if arg == "0" or arg == "off"
			player.ryderflipaim = 0
			if io and player == consoleplayer
				local file = io.openlocal("client/Ryder.dat", "w+")
				file:write(player.ryderflipaim)
				file:close()
			end
		elseif arg == "1" or arg == "default" or arg == "on"
			player.ryderflipaim = 1
			if io and player == consoleplayer
				local file = io.openlocal("client/Ryder.dat", "w+")
				file:write(player.ryderflipaim)
				file:close()
			end
		else
			CONS_Printf(player, "ryderflipaim [on/off] - When on, Ryder's vertical aiming while throwing will be reversed.")
			if player.ryderflipaim
				CONS_Printf(player, "Currently on.")
			else
				CONS_Printf(player, "Currently off.")
			end
		end
	else
		CONS_Printf(player, "ryderflipaim [on/off] - When on, Ryder's vertical aiming while throwing will be reversed.")
		if player.ryderflipaim
			CONS_Printf(player, "Currently on.")
		else
			CONS_Printf(player, "Currently off.")
		end
	end
end
COM_AddCommand("ryderflipaim", ryderflipaim)
COM_AddCommand("ryderflipaim2", ryderflipaim, COM_SPLITSCREEN)

//Thok
mobjinfo[freeslot("MT_RYDER_THOK")] = {
	spawnstate = mobjinfo[MT_THOK].spawnstate,
	height = mobjinfo[MT_THOK].height,
	radius = mobjinfo[MT_THOK].radius,
	flags = mobjinfo[MT_THOK].flags,
}

addHook("MobjThinker", function(mobj)
	mobj.frame = FF_TRANS70
	mobj.fuse = mobj.tics
	
	mobj.spritexscale = $*3/2
	mobj.spriteyscale = $*3/2
	
	mobj.type = MT_THOK
	
	local player = mobj.target and mobj.target.valid
	and mobj.target.skin == "ryder" and mobj.target.player
	if player
		if player.powers[pw_super]
			mobj.color = SKINCOLOR_MAGENTA
		else
			mobj.color = SKINCOLOR_PURPLE
		end
	end
end, MT_RYDER_THOK)

//Indicator
mobjinfo[freeslot("MT_RYDER_INDICATOR")] = {
	spawnstate = S_INVISIBLE,
	spawnhealth = 1000,
	height = 1,
	radius = 16*FRACUNIT,
	flags = MF_SCENERY,
}

addHook("MobjMoveCollide", function(thok, mobj)
	if mobj and mobj.valid and mobj.health and not mobj.player
	and mobj.flags & (MF_SOLID|MF_SHOOTABLE|MF_SPRING)
	and thok.z - thok.scale <= mobj.z + mobj.height
	and thok.z + thok.height + thok.scale >= mobj.z
		if mobj.flags & MF_SHOOTABLE
		and mobj.type != MT_RYDER_ROCKBLOCK
			thok.threshold = 69
		else
			thok.threshold = 1
		end
	end
end, MT_RYDER_INDICATOR)

//Rock wall
states[freeslot("S_RYDER_ROCKWALL")] = {SPR_RYD1, FF_PAPERSPRITE, -1, nil, 0, 0, S_NULL}
mobjinfo[freeslot("MT_RYDER_ROCKWALL")] = {
	spawnstate = S_RYDER_ROCKWALL,
	spawnhealth = 1000,
	height = 1,
	radius = 16*FRACUNIT,
	flags = MF_NOBLOCKMAP|MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY,
}

//Rock wall thinker
addHook("MobjThinker", function(mobj)
	if not mobj.threshold then return end
	local tracer = mobj.tracer
	
	if not (tracer and tracer.valid)
		P_RemoveMobj(mobj)
		return
	end
	
	local health = tracer.health
	if not health then tracer.health = 1 end
	
	A_CapeChase(mobj,1,0)
	tracer.health = health
	
	mobj.scale = tracer.scale
	mobj.target = tracer.tracer
	mobj.frame = ($ &~ FF_TRANSMASK) | (tracer.flags2 & MF2_SHADOW and FF_TRANS90 or 0)
	
	local target = mobj.target
	if multiplayer and target and target.valid and target.player
		mobj.color = target.player.skincolor
		mobj.colorized = true
	elseif mobj.colorized
		mobj.colorized = false
	end
	
	if mobj.threshold == 7
		mobj.radius = tracer.radius + tracer.scale
		mobj.height = tracer.height
	elseif mobj.threshold > 4
		mobj.renderflags = $ | RF_FLOORSPRITE | RF_NOSPLATBILLBOARD
		mobj.spritexscale = FixedDiv(tracer.radius, mobj.scale)/64
		mobj.spriteyscale = mobj.spritexscale
		
		mobj.spriteyoffset = -64*FRACUNIT
		mobj.angle = 0
		
		if mobj.threshold & 1 and tracer.threshold <= 1
			mobj.shadowscale = FRACUNIT*2
		else
			mobj.z = $ + tracer.height*P_MobjFlip(mobj)
		end
		
		if tracer.threshold > 1
			mobj.frame = ($ &~ FF_FRAMEMASK) | L
		elseif mobj.threshold & 1
			mobj.frame = ($ &~ FF_FRAMEMASK) | (tracer.extravalue1 + G)
		else
			mobj.frame = ($ &~ FF_FRAMEMASK) | (tracer.extravalue1 + D)
		end
	else
		mobj.angle = mobj.movedir
		local angle = mobj.angle - ANGLE_90
		local thrust = tracer.radius
		P_TeleportMove(mobj, mobj.x + P_ReturnThrustX(nil, angle, thrust),
		mobj.y + P_ReturnThrustY(nil, angle, thrust), mobj.z)
		
		thrust = FixedDiv($, tracer.scale)
		mobj.spritexscale = thrust/64
		mobj.spriteyscale = FixedDiv(tracer.height, tracer.scale)/128
		
		if tracer.threshold > 1
			mobj.frame = ($ &~ FF_FRAMEMASK) | K
		else
			mobj.frame = ($ &~ FF_FRAMEMASK) | tracer.extravalue1
		end
	end
	
	if not (leveltime % 5) and tracer.theshold and not P_IsObjectOnGround(tracer)
	and (tracer.momx or tracer.momy or tracer.momz)
		local ghost = P_SpawnGhostMobj(mobj)
		ghost.renderflags = mobj.renderflags
		
		ghost.spritexscale = mobj.spritexscale
		ghost.spriteyscale = mobj.spriteyscale
		
		ghost.spritexoffset = mobj.spritexoffset
		ghost.spriteyoffset = mobj.spriteyoffset
		
		ghost.height = mobj.height
		ghost.z = mobj.z
	end
end, MT_RYDER_ROCKWALL)

//Rock spin death
addHook("TouchSpecial", function(mobj, mo)
	local player = mo and mo.valid and mo.player
	if player and mobj.tracer and mobj.tracer.valid and mobj.tracer.threshold
	and mo.z + mo.scale <= mobj.z + mobj.height
	and mo.z + mo.height - mo.scale >= mobj.z
		local pflags = player.pflags
		local charflags = player.charflags
		player.pflags = $ &~ PF_BOUNCING &~ PF_GLIDING
		if player.pflags & PF_JUMPED
			player.pflags = $ &~ PF_JUMPED &~ PF_SPINNING
		end
		player.charflags = $ &~ SF_STOMPDAMAGE
		mobj.flags = $ | MF_MONITOR
		
		if P_PlayerCanDamage(player, mobj)
			mobj.flags = $ &~ MF_MONITOR
			P_KillMobj(mobj.tracer)
		else
			mobj.flags = $ &~ MF_MONITOR
		end
		player.pflags = pflags
		player.charflags = charflags
	end
	return true
end, MT_RYDER_ROCKWALL)

//Rock block
mobjinfo[freeslot("MT_RYDER_ROCKBLOCK")] = {
	spawnstate = S_INVISIBLE,
	seesound = sfx_crumbl,
	deathsound = sfx_cdfm32,
	spawnhealth = 1,
	speed = 96*FRACUNIT,
	height = 96*FRACUNIT,
	radius = 48*FRACUNIT,
	flags = MF_SCENERY|MF_NOCLIP|MF_NOCLIPHEIGHT|MF_NOCLIPTHING|MF_NOGRAVITY|MF_PUSHABLE,
}

//Rock block spawn
addHook("MobjSpawn", function(mobj)
	for i = 1, 7
		local wall = P_SpawnMobjFromMobj(mobj, 0,0,0, MT_RYDER_ROCKWALL)
		wall.target = mobj.tracer
		wall.tracer = mobj
		wall.movedir = ANGLE_90 * i
		wall.threshold = i
		
		if i == 7
			wall.flags = MF_SCENERY|MF_NOGRAVITY|MF_SPECIAL|MF_NOCLIP|MF_NOCLIPHEIGHT
			wall.state = S_INVISIBLE
		end
	end
	
	mobj.flags = $ &~ MF_PUSHABLE
	mobj.flags2 = $ | MF2_SLIDEPUSH
	mobj.fuse = 2
end, MT_RYDER_ROCKBLOCK)

//Rock block thinker
addHook("MobjThinker", function(mobj)
	mobj.angle = 0
	if not mobj.health then return end
	
	if mobj.threshold == 2
		if (P_MobjFlip(mobj) >= 0 and P_CeilingzAtPos(mobj.x, mobj.y, mobj.z, mobj.height) - (mobj.z + mobj.height) < 96*mobj.scale)
		or (P_MobjFlip(mobj) < 0 and mobj.z - P_FloorzAtPos(mobj.x, mobj.y, mobj.z, mobj.height)  < 96*mobj.scale)
			mobj.fuse = 1
			mobj.momz = 0
			return
		end
		
		mobj.height = $ + abs(mobj.momz)
		if P_MobjFlip(mobj) >= 0
			mobj.z = $ - mobj.momz
		end
		return
	elseif mobj.threshold > 1
		return
	end
	
	//Crushed
	if not (mobj.flags & (MF_NOCLIP|MF_NOCLIPHEIGHT))
	and mobj.ceilingz - mobj.floorz < mobj.height
		P_KillMobj(mobj)
		return
	end
	
	if P_IsObjectOnGround(mobj) and mobj.eflags & MFE_JUSTHITFLOOR
		mobj.friction = $/2
	end
	RyderButteredSlope(mobj)
	
	if mobj.eflags & MFE_TOUCHLAVA and mobj.eflags & MFE_UNDERWATER
	and not (mobj.eflags & MFE_GOOWATER)
	and mobj.momz * P_MobjFlip(mobj) <= P_GetMobjGravity(mobj) * -8
		mobj.momx = $ * 15/16
		mobj.momy = $ * 15/16
		mobj.momz = $ - P_GetMobjGravity(mobj) * 2
		P_TryMove(mobj, mobj.x, mobj.y, true)
	end
	
	if mobj.flags & MF_NOCLIP
		//nothing
	elseif mobj.cusval
		if not P_IsObjectOnGround(mobj)
			mobj.cusval = 0
		end
	elseif P_IsObjectOnGround(mobj)
		S_StartSound(mobj, sfx_s3k49)
		mobj.cusval = 1
	end
end, MT_RYDER_ROCKBLOCK)

addHook("MobjMoveBlocked", function(mobj)
	if FixedHypot(mobj.momx, mobj.momy) > mobj.radius/4
		S_StartSound(mobj, sfx_s3k49)
	end
	
	if not P_IsObjectOnGround(mobj)
		mobj.momx = $/2
		mobj.momy = $/2
	end
end, MT_RYDER_ROCKBLOCK)

//Rock block solidify
addHook("MobjFuse", function(mobj)
	if mobj.threshold == 2
		S_StopSound(mobj)
		mobj.momz = 0
		
		mobj.threshold = $ + 1
	elseif mobj.threshold
		P_KillMobj(mobj)
	else
		mobj.flags = MF_SOLID|MF_PUSHABLE|MF_SHOOTABLE
		mobj.flags2 = $ &~ MF2_SHADOW
		mobj.threshold = 1
		
		mobj.z = $ + P_MobjFlip(mobj)
		if mobj and mobj.valid
			if P_CheckPosition(mobj, mobj.x, mobj.y)
			and mobj.z - mobj.floorz < mobj.height*-3/2
				P_KillMobj(mobj)
			end
		end
	end
	
	return true
end, MT_RYDER_ROCKBLOCK)

//Rock block die
addHook("MobjDeath", function(mobj)
	local color = multiplayer and mobj.target and mobj.target.valid
	and mobj.target.player and mobj.target.player.skincolor
	
	//Dumb debris
	local radius = FixedDiv(mobj.radius, mobj.scale)
	local height = FixedDiv(mobj.height, mobj.scale)
	for z = 0, 3 for i = -1, 1 for d = -1, 1
		local rock = P_SpawnMobjFromMobj(mobj, radius*2/3*d, radius*2/3*i,
		height - (height/3*z), MT_ROCKCRUMBLE2)
		if rock and rock.valid
			rock.state = S_RYDER_CRUMBLE
			rock.flags2 = $ &~ MF2_OBJECTFLIP
			rock.eflags = $ &~ MFE_VERTICALFLIP
			
			if color then rock.color = color rock.colorized = true end
		
			P_InstaThrust(rock, R_PointToAngle2(mobj.x, mobj.y, rock.x, rock.y),
			R_PointToDist2(rock.x, rock.y, mobj.x, mobj.y)/16)
		end
	end end end
	
	local ghost = P_SpawnGhostMobj(mobj)
	if ghost and ghost.valid
		ghost.fuse = TICRATE
		S_StartSound(ghost, mobj.threshold > 1 and sfx_crumbl or mobj.info.deathsound)
	end
end, MT_RYDER_ROCKBLOCK)

//Rock block damage
addHook("MobjMoveCollide", function(mobj, target)
	if mobj and mobj.valid and mobj.health and target and target.valid
	and target.health and mobj.type != target.type
	and (target.flags & MF_SHOOTABLE or target.flags & MF_MISSILE
	or target.type == MT_RING or target.type == MT_COIN
	or target.type == MT_SPIKE or target.type == MT_WALLSPIKE
	or target.type == MT_EGGSHIELD or target.type == MT_METALSONIC_BATTLE
	or (mobj.threshold == 2 and (target.flags & MF_PUSHABLE)))
	and target.z - target.scale <= mobj.z + mobj.height
	and target.z + target.height + target.scale >= mobj.z
		if mobj.threshold == 2 and (target.flags & MF_PUSHABLE or target.player)
			if P_MobjFlip(mobj) == P_MobjFlip(target)
				if P_MobjFlip(mobj) >= 0
					target.z = mobj.z + mobj.height
				else
					target.z = $ - mobj.scale
				end
				target.momz = mobj.fuse != 1 and mobj.momz or 0
				target.pmomz = 0
				target.eflags = $ &~ MFE_APPLYPMOMZ
				
				target.ryderwallride = mobj.fuse
				
				if target.player
					if mobj.tracer == mobj then target.player.ryderthokked = true end
					
					target.player.ryderjump = 5
					target.player.ryderplatformmomz = mobj.momz
					
					if target.skin == "ryder"
						target.state = S_PLAY_GLIDE_LANDING
						target.tics = mobj.fuse
						target.player.pflags = $ &~ PF_SPINNING
						target.player.panim = PA_DASH
						target.player.glidetime = 1
					elseif target.player and target.player.pflags & PF_SPINNING
						target.state = S_PLAY_STND
						target.player.pflags = $ &~ PF_SPINNING
					end
				end
			end
			
		elseif target.player
			if not mobj.theshold then return false end
			
		elseif (target.type == MT_RING or target.type == MT_COIN)
		and mobj.tracer and mobj.tracer.valid and mobj.tracer.player
			if target.info.deathsound == sfx_rnglft
			or target.info.deathsound == sfx_rngrgh
				target.info.deathsound = sfx_itemup
			end
			if mobj.tracer.player == displayplayer
			or mobj.tracer.player == secondarydisplayplayer
				S_StartSound(mobj.tracer, target.info.deathsound)
			else
				S_StartSound(target, target.info.deathsound)
			end
			A_ForceStop(target)
			P_KillMobj(target)
			P_GivePlayerRings(mobj.tracer.player, 1)
			
		elseif target.type == MT_SPIKE or target.type == MT_WALLSPIKE
			P_KillMobj(target, mobj, mobj.tracer or mobj)
			
		elseif mobj.threshold <= 1
		and P_DamageMobj(target, mobj, mobj.tracer or mobj)
			P_KillMobj(mobj)
		end
	end
end, MT_RYDER_ROCKBLOCK)

//Metal Sonic
addHook("MobjCollide", function(mobj, target)
	if mobj and mobj.valid and mobj.health and target and target.valid
	and target.health and target.type == MT_METALSONIC_BATTLE
	and target.state == target.info.spawnstate
	and target.z - target.scale <= mobj.z + mobj.height
	and target.z + target.height + target.scale >= mobj.z
		target.flags2 = $ | MF2_CLASSICPUSH
	end
end, MT_RYDER_ROCKBLOCK)

//Egg Guard Shield
addHook("MobjCollide", function(target, mobj)
	if mobj and mobj.valid and mobj.health and target and target.valid
	and target.health and mobj.type == MT_RYDER_ROCKBLOCK
	and target.z - target.scale <= mobj.z + mobj.height
	and target.z + target.height + target.scale >= mobj.z
		if mobj.threshold <= 1
		and P_KillMobj(target, mobj, mobj.tracer or mobj)
			P_KillMobj(mobj)
		end
	end
end, MT_EGGSHIELD)

rawset(_G, "RyderFindPlayer", function(player)
	if #players <= 1 then return end
	
	local maxdist = FixedMul(RING_DIST/3, player.mo.scale)+player.speed
	local span = ANGLE_45
	local thokmobj = P_SpawnMobjFromMobj(player.mo, 0,0,0, MT_THOK)
	thokmobj.radius = maxdist
	local closestmo = nil
	local closestdist = 0
	
	searchBlockmap("objects", function(refmobj, mobj)
		local trash = R_PointToAngle2(player.mo.x, player.mo.y, mobj.x, mobj.y)
	
		if mobj.flags & MF_NOCLIPTHING or mobj.health <= 0
		or mobj == player.mo or mobj.flags2 & MF2_FRET or not P_CheckSight(player.mo, mobj)
		or ((twodlevel or player.mo.flags2 & MF2_TWOD) and abs(player.mo.y-mobj.y) > player.mo.radius)
		or ((trash - player.mo.angle > span) or (trash - player.mo.angle < -1*span))
		or (player.powers[pw_carry] and player.mo.tracer == mobj)
		or not mobj.player or player.bot == 1
		or mobj.player.spectator or mobj.player.panim == PA_PAIN or G_TagGametype()
		return end
		
		if CBW_Battle
			CBW_Battle.DoSPriority(mobj.player, player.mo)
			if mobj.player.battle_def then return end
		end
	
		local zdist = ((player.mo.z + player.mo.height/2) - (mobj.z + mobj.height/2))*3/2
		local dist = P_AproxDistance(player.mo.x-mobj.x, player.mo.y-mobj.y)
		if ((R_PointToAngle2(0, 0, dist, zdist) + span) > span*2) and ((R_PointToAngle2(0, 0, dist, -1*zdist) + span) > span*2)
			return // Don't home outside of desired angle!
		end

		dist = P_AproxDistance(dist, zdist)
		if (dist > maxdist) or (closestmo and dist > closestdist)
			return // out of range
		end

		closestmo = mobj
		closestdist = dist
	end, thokmobj)
	P_RemoveMobj(thokmobj)
	
	if closestmo and closestmo.valid
		if closestmo.player.powers[pw_carry] == CR_ROPEHANG
			closestmo.tracer = nil
		end
			
		P_ResetPlayer(closestmo.player)
		
		//Destroy the player's minecart without killing them
		if closestmo.player.powers[pw_carry] == CR_MINECART
			closestmo.tracer.target = nil
			P_KillMobj(closestmo.tracer, closestmo, player.mo, 0)
		end
		
		//Ryder uses carry type 13, which is unused normally
		//Except when Yoshi and Milne use it
		closestmo.tracer = player.mo
		closestmo.player.powers[pw_carry] = 13
		closestmo.rydercarried = true
		
		if gametyperules&GTR_FRIENDLY or
		(G_GametypeHasTeams() and closestmo.player.ctfteam == player.ctfteam)
			closestmo.state = S_PLAY_ROLL
		else
			closestmo.state = S_PLAY_PAIN
		end
		
		closestmo.flags = MF_NOCLIPTHING|MF_SLIDEME|MF_NOGRAVITY
		closestmo.flags2 = $&~MF2_DONTDRAW
		S_StartSoundAtVolume(player.mo, sfx_s3k8a, 128)
		
		return closestmo
	end
end)

//Spin ability
addHook("SpinSpecial", function(player)
	local mo = player.mo
	local rock = player.ryderrock
	if RyderCantMove(player)
	or player.pflags & PF_SPINDOWN
	or (not P_IsObjectOnGround(mo) and not rock)
	or player.weapondelay
	or player.exiting
		return
	end
	
	//Rock throw!
	if rock and rock.valid
		if player.ryderrocktimer <= PICKUPTIME then return end
		
		mo.angle = player.cmd.angleturn<<16
		player.drawangle = mo.angle
		
		S_StartSound(mo, sfx_mswing)
		S_StartSound(mo, sfx_s3kd3s)
		
		mo.state = S_PLAY_FIRE
		mo.tics = $ + 1
		player.weapondelay = TICRATE/3
		
		local speed = player.powers[pw_super] and 2*THROWSPEED or THROWSPEED
		P_InstaThrust(rock, mo.angle, FixedMul(speed*sin(player.ryderthrowangle), mo.scale) + player.speed)
		rock.momz = FixedMul(speed*cos(player.ryderthrowangle), mo.scale)
		
		if rock.player
			P_ResetPlayer(rock.player)
			rock.flags = rock.info.flags
			rock.rydercarried = nil
			
			if gametyperules&GTR_FRIENDLY or
			(G_GametypeHasTeams() and rock.player.ctfteam == player.ctfteam)
				rock.state = S_PLAY_ROLL
				rock.player.pflags = $ | PF_SPINNING
			else
				rock.state = S_PLAY_PAIN
			end
		else
			rock.flags = MF_SHOOTABLE
			if player.ryderthrowangle < ANGLE_45 or player.ryderthrowangle > ANGLE_135
				rock.fuse = 7
			else
				rock.fuse = 5
			end
		end
		
		local thok = P_SpawnMobjFromMobj(rock, 0,0,0, MT_THOK)
		thok.target = rock
		A_CapeChase(thok, rock.info.height/2,0)
		thok.scale = $/4
		if P_MobjFlip(thok) < 0 then thok.z = $ + thok.height*3 end
		thok.destscale = $*16
		thok.angle = mo.angle - ANGLE_90
		thok.sprite = SPR_BAL2
		thok.frame = F|FF_PAPERSPRITE
		
		if not rock.player
			rock.flags2 = $ &~ MF2_SHADOW
			
			local oldz = rock.z
			rock.z = $ + P_MobjFlip(rock)
			if rock and rock.valid
				if P_CheckPosition(rock, rock.x, rock.y)
				and rock.z - rock.floorz < rock.height*-3/2
					P_KillMobj(rock)
				end
			end
		end
		
		player.ryderrock = nil
		player.ryderrocktimer = 0
		
	//Rock get!
	else
		S_StartSound(mo, sfx_s3kd7s)
		if player == displayplayer or player == secondarydisplayplayer
			P_StartQuake(8*FRACUNIT, 5)
		end
		
		//Angle junk
		player.ryderthrowangle = ANGLE_90
		mo.angle = $
		
		//Spawn rock
		local thrust = FixedDiv(mo.radius, mo.scale) + mobjinfo[MT_RYDER_ROCKBLOCK].radius
		
		rock = RyderFindPlayer(player)
		or P_SpawnMobjFromMobj(mo, P_ReturnThrustX(mo, mo.angle, thrust),
		P_ReturnThrustY(mo, mo.angle, thrust), 0, MT_RYDER_ROCKBLOCK)
		if not rock and rock.valid then return true end
		
		if not rock.player
			rock.target = mo
			rock.tracer = mo
			S_StartSound(rock, rock.info.seesound)
			
			table.insert(player.ryderblocks, rock)
		end
		
		player.ryderrock = rock
		player.ryderrocktimer = 0
		
		//Move rock
		A_FaceTracer(rock)
		local oldx = rock.x
		local oldy = rock.y
		local oldz = rock.z
		P_InstaThrust(rock, rock.angle, P_AproxDistance(mo.x - rock.x, mo.y - rock.y)/PICKUPTIME)
		
		A_CapeChase(rock,1,0)
		if not rock and rock.valid then return true end
		
		rock.z = $ + THROWHEIGHT*mo.scale*P_MobjFlip(mo)
		if not rock and rock.valid then return true end
		
		rock.momz = (rock.z - oldz)/PICKUPTIME
		P_TeleportMove(rock, oldx, oldy, oldz)
		if not rock and rock.valid then return true end
		
		if rock.player then rock.angle = mo.angle return true end
		
		//Rock explosion
		for i = 0, 7
			local crum = P_SpawnMobjFromMobj(rock, 0,0,FRACUNIT, MT_ROCKCRUMBLE2)
			crum.state = S_RYDER_CRUMBLE
			crum.angle = (i*(ANGLE_180/4))
			crum.momx = FixedMul(sin(crum.angle),8*crum.scale)
			crum.momy = FixedMul(cos(crum.angle),8*crum.scale)
			crum.momz = 8*crum.scale*P_MobjFlip(rock)
			crum.flags2 = $ &~ MF2_OBJECTFLIP
			crum.eflags = $ &~ MFE_VERTICALFLIP
			if multiplayer then crum.color = player.skincolor crum.colorized = true end
		end
		
		//Create crack in ground
		if P_IsObjectOnGround(rock)
			local ghost = P_SpawnGhostMobj(rock)
			ghost.sprite = SPR_RYD1
			ghost.frame = J
			ghost.renderflags = $|RF_FLOORSPRITE|RF_NOSPLATBILLBOARD|RF_SHADOWDRAW|RF_OBJECTSLOPESPLAT
			P_CreateFloorSpriteSlope(ghost)
			ghost.flags = $ &~ MF_NOCLIPHEIGHT &~ MF_NOGRAVITY
			ghost.flags2 = rock.flags2 & MF2_OBJECTFLIP
			ghost.eflags = rock.eflags & MFE_VERTICALFLIP
			ghost.height = ghost.scale
			ghost.z = $ - rock.height*P_MobjFlip(ghost)
			ghost.fuse = TICRATE*5
		end
	end
	
	return true
end)

//Pillar spawn
addHook("AbilitySpecial", function(player)
	local mo = player.mo
	if RyderCantMove(player) or player.gotflag or player.gotcrystal
	or ((player.pflags & PF_THOKKED or player.ryderthokked)
	and not (player.charflags & SF_MULTIABILITY) and not player.powers[pw_super])
		return
	end
	
	//Kill our previous one
	if player.ryderwall and player.ryderwall.valid
	and player.ryderwall.health and player.ryderwall.type == MT_RYDER_ROCKBLOCK
		P_KillMobj(player.ryderwall)
	end
	
	player.pflags = $ | PF_THOKKED
	player.ryderthokked = 1
	
	//Just a simple shockwave effect
	local thok = P_SpawnMobjFromMobj(mo, 0,0,0, MT_THOK)
	thok.height = 1
	thok.target = mo
	A_CapeChase(thok,0,0)
	thok.scale = $/4
	thok.scalespeed = $*4
	thok.destscale = $*16
	thok.renderflags = $ | RF_FLOORSPRITE
	thok.sprite = SPR_BAL2
	thok.frame = F
	
	//Spawn it
	local wall = P_SpawnMobjFromMobj(mo, 0,0,0, MT_RYDER_ROCKBLOCK)
	if not wall and wall.valid then return true end
	
	player.ryderwall = wall
	wall.radius = FixedMul(wall.info.radius, wall.scale*2)
	
	wall.threshold = 2
	wall.fuse = TICRATE/2
	wall.momz = 12*mo.scale*P_MobjFlip(mo)
	
	S_StartSound(wall, sfx_s3kccl)
	S_StartSound(mo, sfx_rocks4)
	
	wall.target = mo
	wall.tracer = mo
	A_CapeChase(wall, 0, 0)
	if not wall and wall.valid then return true end
	
	if P_MobjFlip(mo) >= 0
		wall.z = mo.z - wall.height
	else
		wall.z = mo.z + mo.height
	end
	if not wall and wall.valid then return true end
	
	mo.momx = $/2
	mo.momy = $/2
	
	mo.state = S_PLAY_GLIDE_LANDING
	mo.tics = wall.fuse
	player.panim = PA_DASH
	player.glidetime = 1
	
	P_TryMove(wall, wall.x + mo.momx, wall.y + mo.momy, true)
	wall.z = $ - mo.scale*P_MobjFlip(mo)
	
	wall.flags = MF_SOLID|MF_NOGRAVITY|MF_NOCLIPHEIGHT|MF_SHOOTABLE
	
	return true
end)

//I hate this
addHook("JumpSpecial", function(player)
	local mo = player.mo
	if RyderCantMove(player, true)
	or not player.ryderjump or player.ryderjump <= 1
	or player.ryderplatformmomz == nil
	or player.pflags & PF_JUMPDOWN
		return
	end
	
	mo.pmomz = 0
	
	player.pflags = $ &~ PF_JUMPED
	P_DoJump(player)
	
	mo.momz = $ + player.ryderplatformmomz/2
	
	player.ryderjump = 0
	player.ryderplatformmomz = nil
	return true
end)

//Reset our variables
local function ResetRyder(player)
	player.ryderthokked = 0
	player.roughquake = false
	
	player.ryderrock = nil
	player.ryderrocktimer = 0
	player.ryderthrowangle = ANGLE_90
	player.ryderlockon = 0
	
	if player.ryderreset
		player.normalspeed = skins[player.skin].normalspeed
		player.charflags = $ &~ SF_NOSHIELDABILITY
		player.ryderreset = false
	end
	
	if not player.ryderblocks then player.ryderblocks = {} end
	
	if player.mo and player.mo.valid
		player.rydermomz = player.mo.momz
	else
		player.rydermomz = 0
	end
end
for player in players.iterate ResetRyder(player) end

//Reset when spawning and do I/O
addHook("PlayerSpawn", function(player)
	ResetRyder(player)

	//I/O maybe
	if io and player == consoleplayer and player.ryderflipaim == nil
		local file = io.openlocal("client/Ryder.dat")
		if file
			local num = file:read("*l")
			if num
				COM_BufInsertText(consoleplayer, "ryderflipaim "..num)
			end
			file:close()
		end
	end
end)

//Ya can't move!
rawset(_G, "RyderCantMove", function(player, noskin)
	local mo = player.mo
	return not (mo and mo.valid and mo.health and (mo.skin == "ryder" or noskin))
	or P_PlayerInPain(player)
	or player.pflags & PF_SLIDING
	or player.powers[pw_carry]
	or player.spectator
	or player.playerstate
	or player.powers[pw_super] == 1
	or player.iseggrobo
	or player.isjettysyn
	or player.guard
	or player.actionstate
	or (player.airdodge and player.airdodge > 0)
	or player.tumble
	or player.powers[pw_nocontrol]
	or (player.isxmomentum and mo.state == S_PLAY_FACEPLANT)
	or mo.state == S_RYDER_STUN
end)

//If a player leaves, make sure they remove all their rocks first!
local function breakallrocks(player)
	local returnvalue = nil
	
	for i, rock in pairs(player.ryderblocks) do
		if rock and rock.valid and rock.health and rock.type == MT_RYDER_ROCKBLOCK
			P_KillMobj(rock)
			returnvalue = true
		end
	end
	player.ryderblocks = {}
	
	if player.ryderwall and player.ryderwall.valid
	and player.ryderwall.health and player.ryderwall.type == MT_RYDER_ROCKBLOCK
		P_KillMobj(player.ryderwall)
		player.ryderwall = nil
		returnvalue = true
	end
	
	return returnvalue
end
addHook("PlayerQuit", breakallrocks)

//Throw turning
addHook("PlayerCmd", function(player, cmd)
	if player.ryderrock and player.ryderrock.valid
	and player.ryderrocktimer > PICKUPTIME and cmd.sidemove != 0
		cmd.angleturn = $ + (cmd.sidemove*-16)
		cmd.sidemove = 0
	end
end)

addHook("PlayerThink", function(player)
	local mo = player.mo
	
	//Dumb pillar jump
	if player.ryderjump
		player.ryderjump = $ - 1
		
		if player.pflags & PF_SPINNING and not P_IsObjectOnGround(mo)
			mo.state = S_PLAY_SPRING
			player.pflags = $ &~ PF_SPINNING
			if player.pflags & PF_JUMPED
				player.pflags = $ | PF_NOJUMPDAMAGE
			end
		end
		
		if not player.ryderjump
			player.ryderplatformmomz = nil
		end
	end
	
	//Manage the blocks
	if not player.ryderblocks then player.ryderblocks = {} end
	local newblocks = {}
	for i, rock in pairs(player.ryderblocks) do
		if rock and rock.valid and rock.health and rock.type == MT_RYDER_ROCKBLOCK
			table.insert(newblocks, rock)
			rock.target = player.realmo
			rock.tracer = player.realmo
		end
	end
	while #newblocks > MAXBLOCKS
		P_KillMobj(newblocks[1])
		table.remove(newblocks, 1)
	end
	for i, rock in pairs(newblocks) do
		if i == 1 and #newblocks == MAXBLOCKS
			rock.extravalue1 = 2
		elseif (i == 1 and #newblocks == MAXBLOCKS - 1)
		or (i == 2 and #newblocks == MAXBLOCKS)
			rock.extravalue1 = 1
		else
			rock.extravalue1 = 0
		end
	end
	player.ryderblocks = newblocks
	
	if player.ryderwall and player.ryderwall.valid
	and player.ryderwall.health and player.ryderwall.type == MT_RYDER_ROCKBLOCK
		player.ryderwall.target = player.realmo
		player.ryderwall.tracer = player.realmo
		
		if player.gotflag or player.gotcrystal
			P_KillMobj(player.ryderwall)
			player.ryderwall = nil
		end
	end
	
	//Toss flag detection
	if not (player.cmd.buttons & BT_TOSSFLAG)
	or player.rydertossflag == nil
		player.rydertossflag = 0
	else
		player.rydertossflag = $ + 1
	end
	
	//Dumb NiGHTS
	if player.powers[pw_carry] == CR_NIGHTSMODE and mo.skin == "ryder"
		mo.radius = FixedMul(skins["sonic"].radius, mo.scale)
		mo.ryderwasnights = true
	elseif mo.ryderwasnights
		mo.radius = FixedMul(skins[player.skin].radius, mo.scale)
	end
	
	//Prevent the reset of the code under certain circumstances
	if RyderCantMove(player)
		ResetRyder(player)
		return
	end
	
	//Break all your rocks manually
	if mo.skin == "ryder" and player.rydertossflag == 1
	and not player.ryderrock and not player.ryderjump
	and P_IsObjectOnGround(mo) and breakallrocks(player)
		mo.state = S_PLAY_FIRE
		S_StartSoundAtVolume(mo, sfx_s1b9, 128)
		
		if player == displayplayer or player == secondarydisplayplayer
			P_StartQuake(16*FRACUNIT, 10)
		end
	end
	
	//Dumb lockon
	if player.ryderlockon
		player.ryderlockon = $ - 1
	end
	
	//Hold the rock!
	if player.ryderrock
		if player.ryderrock.valid
			local rock = player.ryderrock
			if not rock.player then rock.fuse = 2 end
			
			//Timer
			player.ryderrocktimer = $ + 1
			local reactable = player.ryderrocktimer > PICKUPTIME
			
			//States
			if player.ryderrocktimer <= PICKUPTIME/2
				mo.state = S_PLAY_FLY
				if P_IsObjectOnGround(mo)
					mo.state = S_PLAY_FIRE_FINISH
					mo.state = S_PLAY_FIRE_FINISH
				end
			elseif P_IsObjectOnGround(mo)
				mo.state = S_PLAY_MELEE_LANDING
			else
				mo.state = S_PLAY_MELEE_FINISH
			end
			mo.tics = 2
			
			//Move the rock
			if reactable
				if not rock.player then rock.flags = $ &~ MF_NOCLIPHEIGHT end
				
				rock.tracer = mo
				A_CapeChase(rock,1,0)
				rock.z = $ + THROWHEIGHT*mo.scale*P_MobjFlip(mo)
				A_ForceStop(rock)
				
				//Rock transparency
				if not rock.player
				and (player == displayplayer or player == secondarydisplayplayer)
					rock.flags2 = $ | MF2_SHADOW
				end
			end
			P_TryMove(rock, rock.x + mo.momx, rock.y + mo.momy, true)
			rock.z = $ + mo.momz
			
			//Angle junk
			if reactable
				local move = FRACUNIT*FRACBITS*player.cmd.forwardmove
				if player.pflags & PF_FLIPCAM then move = $*P_MobjFlip(mo) end
				if player.ryderflipaim then move = -$ end
				
				if P_IsObjectOnGround(mo)
					player.ryderthrowangle = min(max(ANGLE_45, $ + move), ANGLE_135)
				elseif P_MobjFlip(mo) >= 0
					player.ryderthrowangle = min(max(ANGLE_45, $ + move), INT32_MAX-ANGLE_11hh)
				else
					player.ryderthrowangle = min(max(ANGLE_11hh, $ + move), ANGLE_135)
				end
			
				mo.angle = player.cmd.angleturn<<16
				if rock.player
					rock.angle = mo.angle
				end
			end
			
			player.drawangle = player.cmd.angleturn<<16
			if rock.player
				rock.player.drawangle = player.drawangle
			end
			
			//Indicator
			if reactable
				for i = 1, 24
					local thok = P_SpawnMobjFromMobj(rock, 0,0,0, MT_RYDER_INDICATOR)
					
					local speed = player.powers[pw_super] and 2*THROWSPEED or THROWSPEED
					P_InstaThrust(thok, mo.angle, FixedMul(speed*sin(player.ryderthrowangle), mo.scale) + player.speed)
					thok.momz = FixedMul(speed*cos(player.ryderthrowangle), mo.scale)
					
					thok.sprite = SPR_RYD6
					thok.tics = 2
					
					thok.renderflags = $ | RF_FULLBRIGHT | RF_NOCOLORMAPS
					thok.color = player.skincolor
					
					thok.height = rock.height
					thok.radius = rock.radius
					thok.z = rock.z
					
					local broke = false
					for j = 1, (i*8 + (leveltime%8) - 8)
						if not P_TryMove(thok, thok.x + thok.momx, thok.y + thok.momy, true)
						or thok.threshold
							broke = true
						end
						P_SceneryZMovement(thok)
						if not (thok and thok.valid) or P_IsObjectOnGround(thok)
						or thok.threshold
							broke = true
						end
						
						if broke
							break
						end
					end
					
					if thok and thok.valid
						if player == displayplayer and not splitscreen
							thok.spritexscale = max($, R_PointToDist2(thok.x, thok.y, mo.x, mo.y)/768)
							thok.spriteyscale = thok.spritexscale
						end
						
						thok.spritexscale = $*3/2
						thok.spriteyscale = $*3/2
						
						if broke
							if thok.threshold == 69
								if skincolors[thok.color].chatcolor == V_MAGENTAMAP
								or skincolors[thok.color].chatcolor == V_REDMAP
								or skincolors[thok.color].chatcolor == V_ROSYMAP
									thok.color = SKINCOLOR_EMERALD
								else
									thok.color = SKINCOLOR_RED
								end
								
								if not player.ryderlockon
									S_StartSoundAtVolume(nil, sfx_kc39, 128, player)
								end
								player.ryderlockon = 2
							end
							
							thok.spritexscale = $*3/2
							thok.spriteyscale = $*3/2
							thok.frame = ($ &~ FF_FRAMEMASK) | B
							break
						end
					end
				end
			end
			
			//Prevent Ryder from moving
			if reactable
				player.normalspeed = 0
				player.charflags = $ | SF_NOSHIELDABILITY
				
				//Prevent Ryder from turning Super
				if P_SuperReady(player) and not P_IsObjectOnGround(mo)
				and not player.climbing and not player.powers[pw_carry]
				and not (player.pflags & (PF_GLIDING|PF_SLIDING|PF_SHIELDABILITY))
					player.pflags = $ | PF_SHIELDABILITY
				end
				
				player.ryderreset = true
			else
				player.pflags = $ | PF_STASIS
			end
		else
			player.ryderrock = nil
		end
	elseif player.ryderreset
		player.normalspeed = skins[player.skin].normalspeed
		player.charflags = $ &~ SF_NOSHIELDABILITY
		player.ryderreset = false
	end
	
	//Reset Ryder's ability when you land on real ground (not an object)
	if player.ryderthokked and mo.eflags & MFE_ONGROUND
	and (P_IsObjectOnGround(mo) or mo.eflags & MFE_JUSTHITFLOOR)
		player.ryderthokked = false
	end
	
	//Quakes everytime we land on the ground
	if player.roughquake and (P_IsObjectOnGround(mo) or mo.eflags & MFE_JUSTHITFLOOR
	or (player.rydermomz*P_MobjFlip(mo) <= -40*mo.scale and mo.eflags & MFE_SPRUNG))
		if player.rydermomz*P_MobjFlip(mo) <= -40*mo.scale
			S_StartSound(player.mo, sfx_s3k4c)
			S_StartSound(player.mo,sfx_s3k5f)
			P_Earthquake(player.mo,player.mo,RING_DIST)
			
			if player == displayplayer or player == secondarydisplayplayer
				P_StartQuake(max(min(player.speed*2, 64*FRACUNIT), 32*FRACUNIT), 2)
			end
			
			if mo.eflags & MFE_SPRUNG
				mo.momx = $*5/4
				mo.momy = $*5/4
				mo.momz = $*5/4
				S_StartSound(mo, sfx_sprong)
			end
		elseif player == displayplayer or player == secondarydisplayplayer
			S_StartSoundAtVolume(player.mo, sfx_s3k4c, 128)
			
			if player.rydermomz*P_MobjFlip(mo) <= -20*mo.scale
				S_StartSoundAtVolume(player.mo, sfx_s3k49, 96)
				P_StartQuake(max(min(player.speed, 24*FRACUNIT), 12*FRACUNIT), 2)
			end
		end
		player.roughquake = false
	end
	
	//Extra gravity
	if P_IsObjectInGoop(mo)
		player.glidetime = 0
		player.roughquake = false
	elseif not P_IsObjectOnGround(mo) and mo.momz*P_MobjFlip(mo) <= 0
	and player.panim == PA_FALL and (player.glidetime or player.roughquake)
	and player.pflags & PF_JUMPED and player.pflags & PF_NOJUMPDAMAGE
	and not player.powers[pw_justsprung] and not player.powers[pw_noautobrake]
	and not (mo.eflags & MFE_SPRUNG)
		mo.momz = $ + P_GetMobjGravity(mo)*2
		
		// "Blur" a bit when you are falling fast enough
		if not player.powers[pw_super] and not player.powers[pw_sneakers]
		and player.rydermomz*P_MobjFlip(mo) <= -40*mo.scale
			local gmobj = P_SpawnGhostMobj(mo)
			gmobj.fuse = 2
			if gmobj.tracer and gmobj.tracer.valid
				gmobj.tracer.fuse = 2
			end
			
			if leveltime & 1
				gmobj.frame = ($ &~ FF_TRANSMASK) | FF_TRANS70
				if gmobj.tracer and gmobj.tracer.valid
					gmobj.tracer.frame = ($ &~ FF_TRANSMASK) | FF_TRANS70
				end
			end

			if (player == displayplayer
			and not (CV_FindVar("chasecam") and CV_FindVar("chasecam").value))
			or (player == secondarydisplayplayer
			and not (CV_FindVar("chasecam2") and CV_FindVar("chasecam2").value))
				gmobj.flags2 = $ | MF2_DONTDRAW
			end
		end
		
		player.roughquake = true
		player.glidetime = 0
	else
		player.roughquake = false
	end
	
	//Ryder's so heavy that he literally just shatters floors with his own weight
	if mo.subsector and mo.subsector.valid
	and mo.subsector.sector and mo.subsector.sector.valid
		for fof in mo.subsector.sector.ffloors()
			if not (fof.flags & FF_EXISTS) continue end -- Does it exist?
			if not (fof.flags & FF_BUSTUP) continue end -- Is it bustable?
			
			if mo.z + mo.momz + mo.height < fof.bottomheight continue end -- Are we too low?
			if mo.z + mo.momz > fof.topheight continue end -- Are we too high?  
			
			EV_CrumbleChain(fof) -- Crumble
			if fof.master.flags & ML_EFFECT5
				P_LinedefExecute(P_AproxDistance(fof.master.dx, fof.master.dy)>>FRACBITS, mo, fof.target)
			end
		end
	end
	
	player.rydermomz = mo.momz
end)

local function transform(mo)
	for d = 0, 16
		P_SpawnParaloop(mo.x, mo.y, mo.z + mo.height,
		64*mo.scale, 16, MT_NIGHTSPARKLE, d*ANGLE_22h, nil, true)
	end
	S_StartSound(mo, sfx_prloop)
	S_StartSound(mo, sfx_s1c3)
	
	if displayplayer and displayplayer.valid
	and (displayplayer == player or displayplayer == flare
	or (displayplayer.mo and displayplayer.mo.valid
	and P_CheckSight(displayplayer.mo, mo)))
		P_FlashPal(displayplayer, PAL_WHITE, 8)
	end
end

//State junk
addHook("PostThinkFrame", do for player in players.iterate
	local mo = player.mo
	if mo and mo.valid
		local wallride = mo.ryderwallride or 0
		mo.ryderwallride = nil
		if not mo.health then mo.rydercarried = nil continue end
		
		//Being carried
		if mo.rydercarried
			local tracer = mo.tracer
			if player.powers[pw_carry] == 13 and tracer and tracer.valid
			and tracer.player and tracer.player.ryderrock == mo
				if player.pflags & PF_JUMPED
					tracer.player.ryderrock = nil
					mo.flags = mo.info.flags
					P_ResetPlayer(player)
					
					P_DoJump(player, false)
					if not (player.pflags & PF_JUMPDOWN)
						player.pflags = $ &~ PF_STARTJUMP
					end
					mo.state = S_PLAY_JUMP
					
					mo.rydercarried = nil
				elseif tracer.player.ryderrocktimer > PICKUPTIME
				and (tracer.player == displayplayer
				or tracer.player == secondarydisplayplayer)
					mo.frame = $ | FF_TRANS90
				end
			else
				mo.flags = mo.info.flags
				P_ResetPlayer(player)
				
				P_DoJump(player, false)
				if not (player.pflags & PF_JUMPDOWN)
					player.pflags = $ &~ PF_STARTJUMP
				end
				mo.state = S_PLAY_JUMP
				
				mo.rydercarried = nil
			end
		end
	
		//Ryder junk
		if mo.skin != "ryder" then continue end
		
		//The awesome
		local flare = player.hugging or player.hugged
		if flare and flare.valid and flare.mo and flare.mo.valid
		and (flare.mo.skin == "flarethelizard" or flare.mo.skin == "flare")
			if not mo.ryderwashugging
				mo.rydernarlok = P_RandomChance(FRACUNIT/10)
				if mo.rydernarlok then transform(mo) end
			end
			mo.ryderwashugging = true
			
			if mo.rydernarlok
				flare.mo.state = S_FLARE_RYDERHUG2
				mo.state = S_RYDER_FLAREHUG2
			else
				flare.mo.state = S_FLARE_RYDERHUG1
				flare.mo.frame = $ + ((leveltime/4) % 4)
				mo.state = S_RYDER_FLAREHUG1
			end
			
			P_TryMove(flare.mo, mo.x, mo.y, true)
			if P_MobjFlip(mo) >= 0
				flare.mo.z = mo.z
			else
				flare.mo.z = mo.z + (mo.height - flare.mo.height)
			end
		elseif mo.state == S_RYDER_FLAREHUG1 or mo.state == S_RYDER_FLAREHUG2
			mo.state = S_PLAY_STND
			if mo.rydernarlok then transform(mo) end
			mo.ryderwashugging = nil
			mo.rydernarlok = nil
		elseif mo.ryderwashugging or mo.rydernarlok
			if mo.rydernarlok then transform(mo) end
			mo.ryderwashugging = nil
			mo.rydernarlok = nil
		end
		
		//Ryder knockback (works way better than hijacking MobjDamage Tripel!)
		if P_PlayerInPain(player) and mo.state == S_PLAY_PAIN
		and player.powers[pw_flashing] == flashingtics
			mo.z = $ - mo.momz
			mo.momz = 0
			
			mo.state = S_RYDER_STUN
			player.panim = PA_DASH
		elseif player.roughquake 
			if mo.state == S_PLAY_NIGHTS_FLOAT
				mo.state = S_PLAY_FALL
			end
		elseif mo.state == S_PLAY_FALL
			mo.state = S_PLAY_NIGHTS_FLOAT
		end
		
		if mo.state == S_RYDER_STUN
			player.powers[pw_justsprung] = mo.tics
			player.powers[pw_flashing] = flashingtics + mo.tics - 2
			
			player.pflags = $ | PF_STASIS
			mo.friction = FRACUNIT
			
			if P_IsObjectOnGround(mo)
				P_SpawnSkidDust(player, mo.radius, not (mo.tics % 3))
			end
			
			mo.ryderwasstun = true
		elseif mo.ryderwasstun
			player.powers[pw_flashing] = flashingtics - 2
			if not P_IsObjectOnGround(mo) and not RyderCantMove(player)
			and not (player.pflags & PF_JUMPED)
				mo.state = S_PLAY_PAIN
			end
			mo.ryderwasstun = false
		end
		
		//Air hold
		if mo.state == S_PLAY_FIRE_FINISH and not P_IsObjectOnGround(mo)
			mo.state = S_PLAY_FLY
		end
		
		//Transparent Ryder
		if (player == displayplayer or player == secondarydisplayplayer)
		and player.ryderrock and player.ryderrock.valid
		and player.ryderrocktimer > PICKUPTIME
			mo.frame = $ | FF_TRANS90
		end
		
		//Pillar junk
		if player.ryderjump and wallride and mo.state != S_PLAY_GLIDE_LANDING
			mo.state = S_PLAY_GLIDE_LANDING
			player.panim = PA_DASH
			mo.tics = wallride
		end
		
		if mo.state == S_PLAY_GLIDE_LANDING
			player.glidetime = 1
			if not P_IsObjectOnGround(mo)
				if not player.ryderjump
					mo.state = S_PLAY_JUMP
					player.pflags = $ | P_GetJumpFlags(player)
				elseif wallride and wallride <= 2
					mo.momz = 0
				end
			end
		end
		
		//Get our fast fall ready
		if not RyderCantMove(player)
		and player.pflags & PF_STARTJUMP and mo.state == S_PLAY_JUMP
			player.glidetime = 1
		end
	end
end end)